!...5...10...15...20...25...30...35...40...45...50...55...60...65...70...75...80
!
      SUBROUTINE DLAY(U,Y,NSTEP)
!
! 6-channel Signal delay
!
! Author:  Lennart ngquist
!
! Date:    2011-11-22
!
! Input : U (6-vector)

! Output: Y (6-vector)

! Delay : NSTEP (# of DELT)

! Storage in circular buffer 100*6 long

! includes
      INCLUDE "nd.h"
      INCLUDE "emtstor.h"
      INCLUDE "s1.h"
      
      IMPLICIT NONE

      INTEGER NSTEP,INDXIN,INDXOUT,NIN,NOUT,NI,NF
      REAL    U(6),Y(6)

! get and update stack pointer
      NI     = NSTORI
      NSTORI = NI + 1

      NF     = NSTORF
      NSTORF = NF + 600

! initialize buffer and pointer
      IF ( TIMEZERO ) THEN
        STORF(NF:NF+599) = 0
        STORI(NI)        = 0
      ENDIF

! determine pointers to block
      INDXIN  = MODULO(STORI(NI),100)
      INDXOUT = MODULO(INDXIN-NSTEP,100)
      
! read output
      IF ( NSTEP .EQ. 0 ) THEN
        Y = U
      ELSE
        NOUT = NF + 6*INDXOUT
        Y    = STORF(NOUT:NOUT+5)
      ENDIF

! load buffer
      NIN  = NF + 6*INDXIN
      STORF(NIN:NIN+5) = U

! advance pointer
      STORI(NI) = MODULO(INDXIN+1,100)

      RETURN
      END SUBROUTINE
      

